SystemOrganization addCategory: #'Zinc-WebSocket-Tests'!

TestCase subclass: #ZnWebSocketFrameTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-WebSocket-Tests'!

!ZnWebSocketFrameTests commentStamp: '<historical>' prior: 0!
I am ZnWebSocketFrameTests.
!

!ZnWebSocketFrameTests methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 8/21/2012 22:31'!
testReadingSingleFrameMaskedTextMessage
	"Second example from RFC 6455 section 5.7"
	
	| bytes frame |
	bytes := ByteArray readHexFrom: '818537fa213d7f9f4d5158'.
	frame := ZnWebSocketFrame readFrom: bytes readStream.
	self assert: frame isText.
	self assert: frame isMasked.
	self assert: frame contents equals: 'Hello'! !

!ZnWebSocketFrameTests methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 8/21/2012 22:31'!
testReadingSingleFrameUnmaskedTextMessage
	"First example from RFC 6455 section 5.7"

	| bytes frame |
	bytes := ByteArray readHexFrom: '810548656c6c6f'.
	frame := ZnWebSocketFrame readFrom: bytes readStream.
	self assert: frame isText.
	self deny: frame isMasked.
	self assert: frame contents equals: 'Hello'! !

TestCase subclass: #ZnWebSocketTests
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Zinc-WebSocket-Tests'!

!ZnWebSocketTests commentStamp: '<historical>' prior: 0!
I am ZnWebSocketTests.!

!ZnWebSocketTests methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 8/21/2012 22:38'!
testEchoLocally
	| webSocket message |
	ZnServer startDefaultOn: 1701.
	ZnServer default logToTranscript.
	ZnServer default delegate
		map: 'ws-test' 
		to: [ :request | ZnResponse ok: (ZnEntity html: ZnWebSocketDelegate wsTestHtml) ];
		map: 'ws-test-local' 
		to: [ :request | ZnResponse ok: (ZnEntity html: ZnWebSocketDelegate wsTestLocalHtml) ];
		map: 'ws-echo'
		to: [ :request | ZnWebSocketDelegate new handleRequest: request ].
	webSocket := ZnWebSocket to: 'ws://localhost:1701/ws-echo'.
	message := 'Greetings from Pharo Smalltalk @ ', TimeStamp now printString.
	webSocket sendMessage: message.
	self assert: webSocket readMessage equals: message.
	webSocket close.
	ZnServer stopDefault.! !

!ZnWebSocketTests methodsFor: 'testing' stamp: 'SvenVanCaekenberghe 8/21/2012 22:36'!
testEchoWebSocketsDotOrg
	| webSocket message |
	webSocket := ZnWebSocket to: 'ws://echo.websocket.org'.
	message := 'Greetings from Pharo Smalltalk @ ', TimeStamp now printString.
	webSocket sendMessage: message.
	self assert: webSocket readMessage equals: message.
	webSocket close.! !
